%define favor up smp enterprise secure
%define kernel_version %(/bin/bash %{SOURCE1})
%define required_kernel %(echo %kernel_version | /usr/bin/perl -pe 's/(.*)-([^-]*mdk)/$1.$2/')
%{expand:%%define build_modules %(if [[ `/bin/uname -r|sed 's/-.*$//'` < 2.4.21 ]]; then echo 1; else echo 0; fi)}
#- how to use the following: rpm --without modules -ba SPECS/...
%{?_with_modules: %{expand: %%define build_modules 1}}
%{?_without_modules: %{expand: %%define build_modules 0}}

%define real_name eagle
%define name adiusbadsl
%define real_version  1.0.4
%define rname %{name}_kernel-%{kernel_version}
%define version 1.0.4
%define release 1mdk
%define url http://eagle-usb.fr.st/

Summary: Firware and utility of Sagem Fast 800 usb modem kernel module.
Name: %{name}
Url: %{url}
Version: %{version}
Release: %{release}
# eagle-1.0.2-cc3.tar.gz -> adiusbadsl-1.0.1.tar.bz2
Source0: %{real_name}-%{real_version}.tar.bz2 	
Source1: version.sh
#Patch0: adiusbadsl-1.0.2-mdkconf.patch.bz2
Patch0: adiusbadsl-%{version}-mdkconf.patch.bz2
#Patch1: adiusbadsl-1.0.1-macros.patch.bz2
#Patch2: adiusbadsl-1.0.1-pppoe.patch.bz2
#Patch3: adiusbadsl-1.0.1-hotplug.patch.bz2
#Patch4: adiusbadsl-1.0.1-path.patch.bz2
#Patch6: adiusbadsl-1.0.1-Makefile-ppc.patch.bz2
License: LGPL
Group: System/Kernel and hardware
BuildRoot: %{_tmppath}/%{name}-buildroot
Prefix: %{_prefix}
Requires: hotplug, ppp >= 2.4.1
%if %{build_modules} 
Requires: %{name}_kernel
%endif
Provides: %{name}

%description 
Firmware and utility for the Sagem Fast 800 usb modem 

%if %{build_modules} 
%package -n %{rname}
Summary: Sagem Fast 800 usb modem kernel module.
Group: System/Kernel and hardware
Requires: kernel-%{required_kernel}, drakxtools >= 1.1.7-79mdk
Provides: %{name}_kernel

%description -n %{rname}
Sagem Fast 800 usb modem support for Linux kernel %{kernel_version}

%package -n %{rname}-smp
Summary: Sagem Fast 800 usb modem kernel module.
Group: System/Kernel and hardware
Requires: kernel-smp-%{required_kernel}, drakxtools >= 1.1.7-79mdk
Provides: %{name}_kernel

%description -n %{rname}-smp
Sagem Fast 800 usb modem support for Linux kernel %{kernel_version}

%package -n %{rname}-enterprise
Summary: Sagem Fast 800 usb modem kernel module.
Group: System/Kernel and hardware
Requires: kernel-enterprise-%{required_kernel}, drakxtools >= 1.1.7-79mdk
provides: %{name}_kernel

%description -n %{rname}-enterprise
Sagem Fast 800 usb modem support for Linux kernel %{kernel_version}

%package -n %{rname}-secure
Summary: Sagem Fast 800 usb modem kernel module.
Group: System/Kernel and hardware
Requires: kernel-secure-%{required_kernel}, drakxtools >= 1.1.7-79mdk
provides: %{name}_kernel

%description -n %{rname}-secure
Sagem Fast 800 usb modem support for Linux kernel %{kernel_version}
%endif

%prep
%setup -q -n %{real_name}-%{real_version}

%patch0 -p1 -b .mdkconf
#%patch1 -p1 -b .macros
#%patch2 -p1 -b .pppoe
#%patch3 -p1 -b .hotplug
#%patch4 -p1 -b .path
#%ifarch ppc
#%patch6 -p1 -b .ppc
#%endif

#find . -type f | xargs chmod -x 

%build
%if %{build_modules}
for favor in %{favor};do
		make clean

		f=$(echo $favor|tr a-z A-Z);
		perl -p -i -e "s|#define __BOOT_KERNEL_$f 0|#define __BOOT_KERNEL_$f 1|" driver/kernel.h
 
		if [[ $favor == up ]];then
				%make -C driver FAVOR=%{kernel_version} driver
		else
				%make -C driver FAVOR=%{kernel_version}$favor driver
		fi

		perl -p -i -e "s|#define __BOOT_KERNEL_$f 1|#define __BOOT_KERNEL_$f 0|" driver/kernel.h
		cp driver/adiusbadsl.o adiusbadsl-$favor
done
%endif

%make -C driver binaryfirmware adiuser
%make -C pppoa

%install
rm -rf $RPM_BUILD_ROOT
%if %{build_modules}
for favor in %{favor};do
		if [[ $favor == up ]];then
				mkdir -p $RPM_BUILD_ROOT/lib/modules/%{kernel_version}/kernel/drivers/usb
				install -m644 adiusbadsl-up $RPM_BUILD_ROOT/lib/modules/%{kernel_version}/kernel/drivers/usb/adiusbadsl.o
		else
				mkdir -p $RPM_BUILD_ROOT/lib/modules/%{kernel_version}${favor}/kernel/drivers/usb
				install -m644 adiusbadsl-$favor $RPM_BUILD_ROOT/lib/modules/%{kernel_version}${favor}/kernel/drivers/usb/adiusbadsl.o
		fi
done

echo "GZIPPING Modules"
find $RPM_BUILD_ROOT/{%_lib}/modules/ -name '*.o'|xargs gzip -9f
%endif

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/analog
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/ppp
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/%{name}
mkdir -p $RPM_BUILD_ROOT/%{_sbindir}
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/hotplug/usb
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/hotplug/%{name}
install -m644 driver/user/sagemf800.conf $RPM_BUILD_ROOT/%{_sysconfdir}/analog/adiusbadsl.conf
install -m644 driver/firmware/*.bin $RPM_BUILD_ROOT/%{_sysconfdir}/analog/
install -m755 driver/user/adictrl $RPM_BUILD_ROOT/%{_sbindir}/
install -m755 driver/user/showstat $RPM_BUILD_ROOT/%{_sbindir}/
install -m755 pppoa/pppoa $RPM_BUILD_ROOT/%{_sbindir}/
install -m755 scripts/hotplug/adiusb* $RPM_BUILD_ROOT/%{_sysconfdir}/hotplug/usb
install -m644 scripts/hotplug/usb.usermap $RPM_BUILD_ROOT/%{_libdir}/hotplug/%{name}/usb.usermap
#- options.adsl file should be modified according to configuration:
#-    user "$USER"
#- from options.adsl.template
install -m644 scripts/ppp/options $RPM_BUILD_ROOT/%{_sysconfdir}/ppp/options.adsl.template
echo "user \"adsl@adsl\"" > $RPM_BUILD_ROOT/%{_sysconfdir}/ppp/options.mire
cat scripts/ppp/options >> $RPM_BUILD_ROOT/%{_sysconfdir}/ppp/options.mire
install -m755 scripts/adsl/* $RPM_BUILD_ROOT/%{_sbindir}/

%post
/usr/sbin/update-usb.usermap || :

%postun
if [ "$1" = 0 ]; then
  /usr/sbin/update-usb.usermap || :
fi

%if %{build_modules}
%post -n %{rname}
depmod -a -F /boot/System.map-%{kernel_version}
echo "Relaunch drakconnect to configure your modem"

%post -n %{rname}-smp
depmod -a -F /boot/System.map-%{kernel_version}smp
echo "Relaunch drakconnect to configure your modem"

%post -n %{rname}-enterprise
depmod -a -F /boot/System.map-%{kernel_version}enterprise
echo "Relaunch drakconnect to configure your modem"

%post -n %{rname}-secure
depmod -a -F /boot/System.map-%{kernel_version}enterprise
echo "Relaunch drakconnect to configure your modem"
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files 
%defattr(-,root,root)
%doc BUGS Changelog FAQ.fr TODO VERSION lisezmoi.txt pppoa/COPYING
/%{_sbindir}/*
/%{_libdir}/hotplug/%{name}
%config(noreplace) /%{_sysconfdir}/analog/*
%config(noreplace) /%{_sysconfdir}/ppp/*
%config(noreplace) /%{_sysconfdir}/hotplug/usb/*

%if %{build_modules}
%files -n %{rname}
%defattr(-,root,root)
%doc driver/COPYING
/lib/modules/%{kernel_version}/kernel/drivers/usb/*.o*

%files -n %{rname}-smp
%defattr(-,root,root)
%doc driver/COPYING
/lib/modules/%{kernel_version}smp/kernel/drivers/usb/*.o*

%files -n %{rname}-enterprise
%defattr(-,root,root)
%doc driver/COPYING
/lib/modules/%{kernel_version}enterprise/kernel/drivers/usb/*.o*

%files -n %{rname}-secure
%defattr(-,root,root)
%doc driver/COPYING
/lib/modules/%{kernel_version}secure/kernel/drivers/usb/*.o*
%endif

%changelog
* Fri Aug 22 2003 Nicolas Planel <nplanel@mandrakesoft.com> 1.0.4-1mdk
- 1.0.4.

* Wed Jul 16 2003 Franois Pons <fpons@mandrakesoft.com> 1.0.4-0.pre5.1.1mdk
- courtesy specs from Philippe Libat.
- fixed --with modules support missing (only --without supported).
- 1.0.4-pre5.1.

* Tue Apr 01 2003 Nicolas Planel <nplanel@mandrakesoft.com> 1.0.3-1mdk
- 1.0.3.
- no more cc release.

* Thu Mar 06 2003 Franois Pons <fpons@mandrakesoft.com> 1.0.2-0.cc5.2mdk
- fixed requires (dropped drakxtools and added ppp).

* Mon Feb 17 2003 Franois Pons <fpons@mandrakesoft.com> 1.0.2-0.cc5.1mdk
- 1.0.2-cc5 from http://eagle-usb.fr.st.

* Fri Jan 31 2003 Franois Pons <fpons@mandrakesoft.com> 1.0.2-0.cc3.1mdk
- use eagle-1.0.2-cc3 driver from http://eagle-usb.fr.st which support
  correctly pppoa and hotplug (among other fixes).

* Fri Dec 06 2002  Nicolas Planel <nplanel@mandrakesoft.com> 1.0.1-4mdk
- Fix adiusbadsl hotplug script
- remove patch usb_usermap

* Tue Nov 26 2002  Stew Benedict <sbenedict@mandrakesoft.com> 1.0.1-3mdk
- ignore rpmlint hardcoded-library-path

* Tue Nov 26 2002  Stew Benedict <sbenedict@mandrakesoft.com> 1.0.1-2mdk
- PPC build - invalid gcc flags (patch6)
- change hardcoded-library-path

* Wed Sep 11 2002  Nicolas Planel <nplanel@mandrakesoft.com> 1.0.1-1mdk
- Generate multiple kernel version from same source 
- Driver, firmware, utility for Sagem ADSL Fast 800 1.0.1
- Note : adiusbadsl_kernel is generate only if kernel < 2.4.20 
  (included since 2.4.20-0.2mdk)

# end of file
